package com.loafle.bridge.discoveryport;

import com.loafle.bridge.discoveryhistory.DiscoveryHistory;
import com.loafle.bridge.discoveryhistory.DiscoveryHistoryRepository;
import com.loafle.bridge.discoveryhost.DiscoveryHost;
import com.loafle.bridge.discoveryport.type.PortType;
import com.loafle.bridge.discoveryservice.DiscoveryService;
import com.loafle.bridge.discoveryzone.DiscoveryZone;
import com.loafle.bridge.discoveryzone.HostScanHistory;
import com.loafle.bridge.discoveryzone.ResultType;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.transaction.Transactional;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by root on 16. 11. 15.
 */

@RestController
public class DiscoveryPortController {

    @Autowired
    DiscoveryPortRepository repository;

    @Autowired
    DiscoveryHistoryRepository repo;

    @RequestMapping(value = "/discoveryPort/{id}", method = RequestMethod.GET)
    public DiscoveryPort get(@PathVariable(value = "id") long id) {
        return repository.findOne(id);
    }

    @RequestMapping(value ="/jack")
    @Transactional
    public void index() {
//        DiscoveryPort p = new DiscoveryPort(PortType.TCP,(short)12786);
//
//        List<DiscoveryService> ss = new ArrayList<>();
//
//        repository.save(p);
//
//        ss.add(new DiscoveryService(p,PortType.TCP,"DNS"));
//        ss.add(new DiscoveryService(p,PortType.TCP,"TEST"));
//        ss.add(new DiscoveryService(p,PortType.TCP,"ABB"));
//
//        p.setServices(ss);
//
//        repository.save(p);

        DiscoveryHistory d = new DiscoveryHistory();
        d.setResult(true);
        d.setStartDate(new Date());
        d.setEndDate(new Date());

        DiscoveryZone z = new DiscoveryZone();
        String cidr = "827452358680";
        String ip = "3232235983";
        z.setCidr(Long.parseLong(cidr));
        z.setIp(Long.parseLong(ip));
        z.setDiscovery(d);

        d.setZone(z);
        // host scan histories
        List<HostScanHistory> hostScanHistories = new ArrayList<HostScanHistory>();
        for( int indexI = 0 ; indexI < 5; ++indexI) {
            HostScanHistory hostScanHistory = new HostScanHistory();
            hostScanHistory.setIp(Long.parseLong(ip));
            hostScanHistory.setCreateDate(new Date());
            hostScanHistory.setSendDate(new Date());
            hostScanHistory.setResultDate(new Date());
            hostScanHistory.setDescription("hgihihihih");
            hostScanHistory.setResultType(ResultType.Success);
            hostScanHistory.setZone(z);
            hostScanHistories.add(hostScanHistory);
        }

        z.setHistories(hostScanHistories);

        List<DiscoveryHost> hl = new ArrayList<>();

        //add host
        for (int i =0 ; i < 10 ; ++i) {
            DiscoveryHost host = new DiscoveryHost(3232235986l,52242420297l);
            host.setZone(z);

            List<DiscoveryPort> p = new ArrayList<DiscoveryPort>();
            host.setPorts(p);

            //add port
            for (int j =0 ; j < 10 ; ++j) {
                DiscoveryPort port = new DiscoveryPort(host, PortType.TCP, 9840);
                p.add(port);

                List<DiscoveryService> ss = new ArrayList<>();

                ss.add(new DiscoveryService(port,PortType.TCP,"DNS"));
                ss.add(new DiscoveryService(port,PortType.TCP,"TEST"));
                ss.add(new DiscoveryService(port,PortType.TCP,"ABB"));

                port.setServices(ss);
            }
            hl.add(host);
        }
        z.setDiscoveryHosts(hl);

        repo.save(d);

        DiscoveryHistory find = repo.findOne(d.getId());
    }
}
